#!/usr/bin/python
# -*- coding: latin-1 -*-
# INTEL CONFIDENTIAL
# Copyright 2007 Intel Corporation All Rights Reserved.
#
# The source code contained or described herein and all documents related to the
# source code (“Material”) are owned by Intel Corporation or its suppliers or
# licensors. Title to the Material remains with Intel Corporation or its
# suppliers and licensors. The Material may contain trade secrets and
# proprietary and confidential information of Intel Corporation and its
# suppliers and licensors, and is protected by worldwide copyright and trade
# secret laws and treaty provisions. No part of the Material may be used,
# copied, reproduced, modified, published, uploaded, posted, transmitted,
# distributed, or disclosed in any way without Intel’s prior express written
# permission. 
# No license under any patent, copyright, trade secret or other intellectual
# property right is granted to or conferred upon you by disclosure or delivery
# of the Materials, either expressly, by implication, inducement, estoppel or
# otherwise. Any license under such intellectual property rights must be express
# and approved by Intel in writing.
#
# Include any supplier copyright notices as supplier requires Intel to use.
#
# Include supplier trademarks or logos as supplier requires Intel to use, preceded
# by an asterisk. An asterisked footnote can be added as follows:
# *Third Party trademarks are the property of their respective owners.
#
# Unless otherwise agreed by Intel in writing, you may not remove or alter this
# notice or any other notice embedded in Materials by Intel or Intel’s suppliers
# or licensors in any way.

"""This module contains the methods to create and update the deployment log file

"""
__author__ = 'Todd C Davis'
__Product__ = 'Intel_PDK'

import os, os.path, sys

BMCfamilies = ['S5000','S5500']

if os.environ.has_key('BootDevice'):
    BootDevice = os.environ['BootDevice']
else:
    print "BootDevice is not set"
    sys.exit(-1)

if os.environ.has_key('DeployPath'):
    DeployPath = os.environ['DeployPath']
else:
    print "DeployPath is not set"
    sys.exit(-1)

if os.environ.has_key('DeploymentStore'):
    if os.path.exists(os.environ['DeploymentStore']):
        DeploymentStore = os.environ['DeploymentStore']
    else:
        print "DeploymentStore %s does not exist"%os.environ['DeploymentStore']
        sys.exit(-1)
else:
    print "DeploymentStore is not set"
    sys.exit(-1)


def getstatusoutput(cmd):
    """Execute the string cmd in a shell with os.system() and return a 2-tuple (status, output). cmd is actually
run as cmd 1> tempfile, so that the returned output is the contents of tempfile. The status is the exit value of cmd.
getstatusoutput(cmd) would have been used but os.popen() does not work because os.pipe() is not impletmented in Windows"""

    if sys.platform == 'linux2':
        import commands
        status, output = commands.getstatusoutput(cmd)
        status = status >> 8
    else:
        import random
        fname = os.path.join(DeploymentStore,'deploy' + str(random.randint(0,1000)) + '.txt')
        cmdstr = '\"'+cmd+'\"' + ' 1> ' + fname
        status = os.system(cmdstr)
        if os.path.exists(fname):
            f = open(fname)
            output = f.read()
            f.close()
            os.remove(fname)
        else:
            output = ""
    return status, output.split('\n')

